diff --git a/contrib/amd/amd/amd.h b/contrib/amd/amd/amd.h
index c896022..0e371b7 100644
--- a/contrib/amd/amd/amd.h
+++ b/contrib/amd/amd/amd.h
@@ -303,4 +758,110 @@ extern am_ops xfs_ops;		/* Un*x file system */
 extern am_ops efs_ops;		/* Un*x file system */
 #endif /* HAVE_FS_EFS */
 
+/**************************************************************************/
+/*** Automounter file-system types, implemented by amd.			***/
+/**************************************************************************/
+
+/*
+ * Root AMD File System
+ */
+extern am_ops amfs_root_ops;	/* Root file system */
+
+/*
+ * Generic amfs helper methods
+ */
+extern am_node *amfs_generic_lookup_child(am_node *mp, char *fname, int *error_return, int op);
+extern am_node *amfs_generic_mount_child(am_node *ap, int *error_return);
+extern int amfs_generic_readdir(am_node *mp, nfscookie cookie, nfsdirlist *dp, nfsentry *ep, u_int count);
+extern int amfs_generic_umount(am_node *mp, mntfs *mf);
+extern void amfs_generic_mounted(mntfs *mf);
+extern char *amfs_generic_match(am_opts *fo);
+extern fserver *amfs_generic_find_srvr(mntfs *);
+
+/*
+ * Automount File System
+ */
+#ifdef HAVE_AMU_FS_AUTO
+extern am_ops amfs_auto_ops;	/* Automount file system (this!) */
+#endif /* HAVE_AMU_FS_AUTO */
+
+/*
+ * Toplvl Automount File System
+ */
+#ifdef HAVE_AMU_FS_TOPLVL
+extern am_ops amfs_toplvl_ops;	/* Toplvl Automount file system */
+extern int amfs_toplvl_mount(am_node *mp, mntfs *mf);
+extern int amfs_toplvl_umount(am_node *mp, mntfs *mf);
+#endif /* HAVE_AMU_FS_TOPLVL */
+
+/*
+ * Direct Automount File System
+ */
+#ifdef HAVE_AMU_FS_DIRECT
+extern am_ops amfs_direct_ops;	/* Direct Automount file system (this too) */
+#endif /* HAVE_AMU_FS_DIRECT */
+
+/*
+ * Error File System
+ */
+#ifdef HAVE_AMU_FS_ERROR
+extern am_ops amfs_error_ops;	/* Error file system */
+extern am_node *amfs_error_lookup_child(am_node *mp, char *fname, int *error_return, int op);
+extern am_node *amfs_error_mount_child(am_node *ap, int *error_return);
+extern int amfs_error_readdir(am_node *mp, nfscookie cookie, nfsdirlist *dp, nfsentry *ep, u_int count);
+#endif /* HAVE_AMU_FS_ERROR */
+
+/*
+ * NFS mounts with local existence check.
+ */
+#ifdef HAVE_AMU_FS_NFSL
+extern am_ops amfs_nfsl_ops;	/* NFSL */
+#endif /* HAVE_AMU_FS_NFSL */
+
+/*
+ * Multi-nfs mounts.
+ */
+#ifdef HAVE_AMU_FS_NFSX
+extern am_ops amfs_nfsx_ops;	/* NFSX */
+#endif /* HAVE_AMU_FS_NFSX */
+
+/*
+ * NFS host - a whole tree.
+ */
+#ifdef HAVE_AMU_FS_HOST
+extern am_ops amfs_host_ops;	/* NFS host */
+#endif /* HAVE_AMU_FS_HOST */
+
+/*
+ * Program File System
+ * This is useful for things like RVD.
+ */
+#ifdef HAVE_AMU_FS_PROGRAM
+extern am_ops amfs_program_ops;	/* Program File System */
+#endif /* HAVE_AMU_FS_PROGRAM */
+
+/*
+ * Symbolic-link file system.
+ * A "filesystem" which is just a symbol link.
+ */
+#ifdef HAVE_AMU_FS_LINK
+extern am_ops amfs_link_ops;	/* Symlink FS */
+#endif /* HAVE_AMU_FS_LINK */
+
+/*
+ * Symbolic-link file system, which also checks that the target of
+ * the symlink exists.
+ * A "filesystem" which is just a symbol link.
+ */
+#ifdef HAVE_AMU_FS_LINKX
+extern am_ops amfs_linkx_ops;	/* Symlink FS with existence check */
+#endif /* HAVE_AMU_FS_LINKX */
+
+/*
+ * Union file system
+ */
+#ifdef HAVE_AMU_FS_UNION
+extern am_ops amfs_union_ops;	/* Union FS */
+#endif /* HAVE_AMU_FS_UNION */
+
 #endif /* not _AMD_H */
diff --git a/contrib/amd/amd/amfs_auto.c b/contrib/amd/amd/amfs_auto.c
index f04cc50..75a451f 100644
--- a/contrib/amd/amd/amfs_auto.c
+++ b/contrib/amd/amd/amfs_auto.c
@@ -1,5 +1,5 @@
 /*
- * Copyright (c) 1997-1999 Erez Zadok
+ * Copyright (c) 1997-2006 Erez Zadok
  * Copyright (c) 1990 Jan-Simon Pendry
  * Copyright (c) 1990 Imperial College of Science, Technology & Medicine
  * Copyright (c) 1990 The Regents of the University of California.
@@ -36,9 +36,8 @@
  * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
  * SUCH DAMAGE.
  *
- *      %W% (Berkeley) %G%
  *
- * $Id: amfs_auto.c,v 1.5 1999/09/30 21:01:29 ezk Exp $
+ * File: am-utils/amd/amfs_auto.c
  *
  */
 
@@ -55,12 +54,7 @@
 /****************************************************************************
  *** MACROS                                                               ***
  ****************************************************************************/
-#define	IN_PROGRESS(cp) ((cp)->mp->am_mnt->mf_flags & MFF_MOUNTING)
 
-/* DEVELOPERS: turn this on for special debugging of readdir code */
-#undef DEBUG_READDIR
-
-#define DOT_DOT_COOKIE (u_int) 1
 
 /****************************************************************************
  *** STRUCTURES                                                           ***
@@ -70,10 +64,7 @@
 /****************************************************************************
  *** FORWARD DEFINITIONS                                                  ***
  ****************************************************************************/
-static int amfs_auto_bgmount(struct continuation * cp, int mpe);
-static int amfs_auto_mount(am_node *mp);
-static int amfs_auto_readdir_browsable(am_node *mp, nfscookie cookie, nfsdirlist *dp, nfsentry *ep, int count, int fully_browsable);
-static void amfs_auto_umounted(am_node *mp);
+static int amfs_auto_mount(am_node *mp, mntfs *mf);
 
 
 /****************************************************************************
@@ -82,19 +73,22 @@ static void amfs_auto_umounted(am_node *mp);
 am_ops amfs_auto_ops =
 {
   "auto",
-  amfs_auto_match,
+  amfs_generic_match,
   0,				/* amfs_auto_init */
   amfs_auto_mount,
-  0,
-  amfs_auto_umount,
-  0,
-  amfs_auto_lookuppn,
-  amfs_auto_readdir,
+  amfs_generic_umount,
+  amfs_generic_lookup_child,
+  amfs_generic_mount_child,
+  amfs_generic_readdir,
   0,				/* amfs_auto_readlink */
-  0,				/* amfs_auto_mounted */
-  amfs_auto_umounted,
-  find_amfs_auto_srvr,
-  FS_AMQINFO | FS_DIRECTORY
+  amfs_generic_mounted,
+  0,				/* amfs_auto_umounted */
+  amfs_generic_find_srvr,
+  0,				/* amfs_auto_get_wchan */
+  FS_AMQINFO | FS_DIRECTORY,
+#ifdef HAVE_FS_AUTOFS
+  AUTOFS_AUTO_FS_FLAGS,
+#endif /* HAVE_FS_AUTOFS */
 };
 
 
@@ -102,65 +96,11 @@ am_ops amfs_auto_ops =
  *** FUNCTIONS                                                             ***
  ****************************************************************************/
 /*
- * AMFS_AUTO needs nothing in particular.
- */
-char *
-amfs_auto_match(am_opts *fo)
-{
-  char *p = fo->opt_rfs;
-
-  if (!fo->opt_rfs) {
-    plog(XLOG_USER, "auto: no mount point named (rfs:=)");
-    return 0;
-  }
-  if (!fo->opt_fs) {
-    plog(XLOG_USER, "auto: no map named (fs:=)");
-    return 0;
-  }
-
-  /*
-   * Swap round fs:= and rfs:= options
-   * ... historical (jsp)
-   */
-  fo->opt_rfs = fo->opt_fs;
-  fo->opt_fs = p;
-
-  /*
-   * mtab entry turns out to be the name of the mount map
-   */
-  return strdup(fo->opt_rfs ? fo->opt_rfs : ".");
-}
-
-
-
-
-/*
- * Build a new map cache for this node, or re-use
- * an existing cache for the same map.
- */
-void
-amfs_auto_mkcacheref(mntfs *mf)
-{
-  char *cache;
-
-  if (mf->mf_fo && mf->mf_fo->opt_cache)
-    cache = mf->mf_fo->opt_cache;
-  else
-    cache = "none";
-  mf->mf_private = (voidp) mapc_find(mf->mf_info, cache,
-				     mf->mf_fo->opt_maptype);
-  mf->mf_prfree = mapc_free;
-}
-
-
-/*
  * Mount a sub-mount
  */
 static int
-amfs_auto_mount(am_node *mp)
+amfs_auto_mount(am_node *mp, mntfs *mf)
 {
-  mntfs *mf = mp->am_mnt;
-
   /*
    * Pseudo-directories are used to provide some structure
    * to the automounted directories instead
@@ -191,7 +131,7 @@ amfs_auto_mount(am_node *mp)
   if (mf->mf_fo->opt_pref) {
     /* allow pref:=null to set a real null prefix */
     if (STREQ(mf->mf_fo->opt_pref, "null")) {
-      mp->am_pref = "";
+      mp->am_pref = strdup("");
     } else {
       /*
        * the prefix specified as an option
